SystemOrganization addCategory: #LightsOut!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightsOut'!

!LOCell methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 9/19/2012 22:14'!
initialize 
	super initialize .
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker .
	self useSquareCorners.
	self turnOff 
	! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightsOut'!

!LOGame methodsFor: 'initialization' stamp: 'AngelaMayhuaQuispe 9/19/2012 23:17'!
cellsPerSide
	"El numero de celdas a lo largo de cada lado del juego"
	^10! !

!LOGame methodsFor: 'initialization' stamp: 'AngelaMayhuaQuispe 9/19/2012 23:05'!
initialize 
	|sampleCell width height n|
	super initialize .
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width .
	height := sampleCell height .
	self bounds: (5@5 extent: ((width *n)@(height *n))+(2*self borderWidth)).
	cells := Matrix new: n tabulate: [:i :j | self newCellAt: i at: j ].! !

!LOGame methodsFor: 'initialization' stamp: 'AngelaMayhuaQuispe 9/19/2012 23:28'!
newCellAt: i at: j
	"Crea una celda en la posicion (i,j) y agrega esto a mi  representacion de pantalla en la posicion apropiada.
	Responde la nueva celda"
	|c origin |
	c := LOCell new.
	origin := self innerBounds origin .
	self addMorph: c.
	c position: ((i-1)*c width )@((j-1)*c height )+origin .
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j]! !
